#define PLUGIN "Bulletin Board Admin Mod"
#define VERSION "1.1c"
#define AUTHOR "[gOf]-Soul"

/* 
* by [gOf]-Soul  from http://www.gofclan.org
*
* This is a very simple plugin I wrote to easily control my admin access 
* based on phpbb user groups.  With 7 servers it became very frustrating 
* to keep up to date on who had what admin access to which servers.  This 
* allows us to do clan tag protection and clan recruitment tag protection 
* on our servers to make sure only authorized people are wearing those tags.
*      By using a clan tag protect plugin and given them the
*      appropriate admin flags
* It also allows us to remove people from the clan and they automatically 
* have their admin privs removed once they are removed from the admin
* groups on the forums.
* 
* **WARNING** **WARNING** **WARNING** **WARNING** **WARNING**
*	This plugin will overwrite your existing users.ini
*	file.  It does this so that if ever your database
*	is unable to be reached there will be a cached version
*	of your admin setup on the server so that people still
*	retain their current admin.
*
* Admins arent granted access immediately through mysql and the forum plugin.
* It takes one map change for new admins to be picked up and for old admins to
* be removed from the system.
*
* I place this plugin above the admin.amxx plugin in the plugins.ini file
* The first time the plugin loads it cannot connect to the database.  I assume
* because maybe some of the helper portions for db access has not been loaded
* yet.  I have never tested this plugin down below where custom plugins 
* normally go.
*
* Requires:
* AmxModX 1.75 and higher
* Mysql DB
*
* Forums Supported:
* PhpBB Forums
*
* Will support more forums is provided with tables and structure I need to hit
*
* To Install:
* Create bbmod.cfg file in your configs directory with the following information
 
	bbmod_sql_host "127.0.0.1"
	bbmod_sql_username "root"
	bbmod_sql_password ""
	bbmod_sql_database "dbname"
	bbmod_phpbb_prefix "phpbb_"
	bbmod_prefix "bbmod_"
	bbmod_advert_show 1
	bbmod_advert_frequency 10
	bbmod_advert_delay 0.2
	bbmod_advert_message 1
	bbmod_advert_dontannoy 0
	bbmod_advert_format 2
	
* Enter your values for the sql host, username, password, database and your 
* database prefix.
*
* If you leave the default value for the bbmod_prefix then two tables will
* be created in your database

	bbmod_version <- Used to keep track from update to update for any
	                 possible database structure updates (automatic)
			 
	bbmod_linker  <- Used to link your phpbb.user_id with your steamid
	                 may integreate some type of forum stats in the future
			 if people are interested
			 
* Create "groups.ini" in your configs directory in the following format:
* "phpbb forum group" "access flags being granted" (one line per group)
	
	"Founders" "acdefghijklmnopqrstu"
	"Clan Leaders" "acdefghijku"
	"Senior Admins" "cdefijku"
	"Junior Admins" "cdeiu"
	"Clan Members" "it"
	"RS All" "b"

* 
* amx_setsteamid usage
*   amx_setsteamid "your username here" "your password here"
*
* Each person or "clan member" in our case must run the amx_setsteamid
* command.  Once they do that a forum link between their steamid and their
* forum user id will be created.  Next map change if they deserve any admin
* flags based on their usergroup membership they will automatically be
* given the appropriate flags
*
* Plugin advertisment can be managed by the advert area of the config file
*  bbmod_advert_show (1|0) 	 // 1 = on, 0 = off
*  bbmod_advert_frequency 10.0   // number of minutes between advertisement popups
*  bbmod_advert_delay 2.0        // number of miunutes to wait before showing first
*			            advertisement
*  bbmod_advert_format (1|2)     // 1 = client print, 2 = hud message, 2 = default 
*  bbmod_advert_dontannoy (1|0)  // 1 = annoy the heck out of them, 0 = only show advert once
*			         //  if dontannoy is set to 1 then advert frequency is ignored

* 1.1c (08-05-2006)
  -Added advert config information to the config file. To give a little more
   control as to how the adverts behave.  Defaults to non annoying mode.
  -Moved the advert to the client_connect to only show it once per map if
   the client has not linked their steamid
  -Changed the name from Soul's DB Mod to Bulletin Board Admin Mod

* 1.1b (07-27-2006)
  -Fixed the amx_setsteamid command so that everyone could run it.
  -Updated documentation with the amx_setsteamid needed information

* 1.1a (07-27-2006)
  -Code cleanup
  -Removing debugging output code
  -Added automatic table creation code
  -Modified to new SQL version to eliminate studdering for remote sql server
  -Added amx_setsteamid command that players run to automatically link their 
   forum account with their steamid

* 1.0 (12-12-2005)
* -Initial creation


///////////////////////////////////////
//                                   //
//   AUTHOR'S ADDITIONAL COMMENTS    //
//                                   //
///////////////////////////////////////
  
Open to all suggestions at this time.  Although we don't use stats on our server
I may end up working some type of stats integration up.  Would consider something
non-obtrusive in a regular php config.  I don't like modifying phpbb config files
so would consider "graphics generation" link to give forum users that would allow
them to show their current stats/ranking information in their signature.

I suggest this might possibly work with hlstats because it takes a long time to copy
amxmodx stats information for 2k people out to the database from inside amxmodx
this is not an option for those of us that use remote mysql databases.
  
*/

#include <amxmodx>
#include <amxmisc>
#include <sqlx>

//#include <dbi>

#define USERID		0
#define USERNAME	1
#define USERFLAGS	2

#define GROUPNAME	0
#define GROUPFLAGS	1

new Groups[50][2][255]
new groupcount = 0
new Admins[255][3][255]
new admincount = 0

new p_bbmod_sql_host
new p_bbmod_sql_username
new p_bbmod_sql_password
new p_bbmod_sql_database
new p_bbmod_phpbb_prefix
new p_bbmod_prefix
new p_advert_show
new p_advert_frequency
new p_advert_delay
new p_advert_format
new p_advert_dontannoy

new s_bbmod_sql_host[64]
new s_bbmod_sql_username[64]
new s_bbmod_sql_password[64]
new s_bbmod_sql_database[64]
new s_bbmod_phpbb_prefix[64]
new s_bbmod_prefix[64]

new Handle:dbtuple
new Handle:mysql

public plugin_init() {
	
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	p_bbmod_sql_host = register_cvar("bbmod_sql_host","127.0.0.1")
	p_bbmod_sql_username = register_cvar("bbmod_sql_username","root")
	p_bbmod_sql_password = register_cvar("bbmod_sql_password","")
	p_bbmod_sql_database = register_cvar("bbmod_sql_database","amx")
	p_bbmod_phpbb_prefix = register_cvar("bbmod_phpbb_prefix","phpbb_")
	p_bbmod_prefix = register_cvar("bbmod_prefix","bbmod_")
	p_advert_show = register_cvar("bbmod_advert_show","1")
	p_advert_frequency = register_cvar("bbmod_advert_frequency","20.0")
	p_advert_delay = register_cvar("bbmod_advert_delay","0.2")
	p_advert_format = register_cvar("bbmod_advert_format","2")
	p_advert_dontannoy = register_cvar("bbmod_advert_dontannoy","1")
	
	ServerOut("++Loading Plugin: %s <> Created By: %s <> Version: %s",PLUGIN,AUTHOR,VERSION)
	
	new configDir[64]
	get_configsdir(configDir, 63)
	server_cmd("exec %s/bbmod.cfg", configDir)
	
	get_pcvar_string(p_bbmod_sql_host,s_bbmod_sql_host,63)
	get_pcvar_string(p_bbmod_sql_username,s_bbmod_sql_username,63)
	get_pcvar_string(p_bbmod_sql_password,s_bbmod_sql_password,63)
	get_pcvar_string(p_bbmod_sql_database,s_bbmod_sql_database,63)
	get_pcvar_string(p_bbmod_phpbb_prefix,s_bbmod_phpbb_prefix,63)
	get_pcvar_string(p_bbmod_prefix,s_bbmod_prefix,63)

	
	dbtuple = SQL_MakeDbTuple(s_bbmod_sql_host, s_bbmod_sql_username, s_bbmod_sql_password, s_bbmod_sql_database)

	//Load groups from group.ini file
	new fileGroups[64];
	format(fileGroups,64,"%s/groups.ini",configDir)
	
	new linelength = 0
	new linetext[64]
	new left[64],right[64]
	
	while(read_file(fileGroups,groupcount,linetext,64,linelength) != 0){
		parse(linetext,left,64,right,64)
		copy(Groups[groupcount][GROUPNAME],255,left)
		copy(Groups[groupcount][GROUPFLAGS],255,right)
		groupcount++
	}
	
	//Open connection to db

	new errnum
	new error[500]
	mysql = SQL_Connect(dbtuple, errnum, error, 254)
	if (!mysql)
	{
		ServerOut(error)
		return PLUGIN_HANDLED
	}
	
	register_clcmd("amx_setsteamid", "set_steam_id", ADMIN_ALL, "<forum username> <forum password>")

	//register_concmd("amx_setsteamid", "set_steam_id", 0, "<forum username> <forum password>")

	//Check for bbmod version table
	// create if it doesnt exist
	// will be used to do auto updates
	// from version to version
	
	new strquery[150]
	format(strquery, 149, "CREATE TABLE IF NOT EXISTS %sversion (\
	version VARCHAR(32) NOT NULL\
	)", s_bbmod_prefix)
	
	new Handle:query = SQL_PrepareQuery(mysql, strquery)
	if (!SQL_Execute(query))
	{
		errnum = SQL_QueryError(query, error, 499)
		server_print("Query failed [%d] %s", errnum, error)
		SQL_FreeHandle(query)
	}
	
	//Query for bbmod version
	format(strquery, 149, "Select version from %sversion",s_bbmod_prefix)
	query = SQL_PrepareQuery(mysql,strquery)
	SQL_Execute(query)
	
	new rows
	if (SQL_NumRows(query)==1)
	{
		//Perform automatic table updating here
		// no updates because no new version of datastructure yet
		
		//Update Version
		format(strquery, 149, "Update %sversion set version = '%s'",s_bbmod_prefix,VERSION)
		SQL_SimpleQuery(mysql,strquery,error,499,rows)
	}
	else
	{
		//First run of bbmod inserting current version 
		//info into version table
		format(strquery, 149, "Insert into %sversion (version) values ('%s')",s_bbmod_prefix,VERSION)
		SQL_SimpleQuery(mysql,strquery,error,499,rows)
	}
	
	
	//Check for linker table
	// create if it doesnt exist
	format(strquery, 149, "CREATE TABLE IF NOT EXISTS %slinker (\
	user_id MEDIUMINT(8) NOT NULL,\
	steamid VARCHAR(32) NOT NULL,\
	PRIMARY KEY(user_id)\
	)", s_bbmod_prefix)
	
	query = SQL_PrepareQuery(mysql, strquery)
	if (!SQL_Execute(query))
	{
		errnum = SQL_QueryError(query, error, 499)
		server_print("Query failed [%d] %s", errnum, error)
		SQL_FreeHandle(query)
	}

	new i
	new whereclause[250]
	new group_flags[255]
	for (i = 0;i<groupcount;i++){

		format(whereclause,250,"(g.group_name = '%s')",Groups[i][GROUPNAME])
		
		new query[500]
		
		format(query,500,"select username,s.steamid,g.group_name from %susers as u \
		left join %suser_group as ug on u.user_id = ug.user_id \
		left join %slinker as s on u.user_id = s.user_id \
		left join %sgroups as g on ug.group_id = g.group_id \
		where (%s) and (left(s.steamid,5) = 'STEAM')\
		",
		s_bbmod_phpbb_prefix,
		s_bbmod_phpbb_prefix,
		s_bbmod_prefix,
		s_bbmod_phpbb_prefix,
		whereclause)
		
		//Query database with the following query...
		//new Result:res = dbi_query(mysql, query)
	
		//Get Users for group		
		new strUsersFile[64]
		format(strUsersFile, 63, "%s/users.out", configDir)
		delete_file (strUsersFile)

		new adminpos
		new Handle:qryGroupUsers = SQL_PrepareQuery(mysql, query)
		if (SQL_Execute(qryGroupUsers))
		{
			while (SQL_MoreResults(qryGroupUsers))
			{
				//ServerOut("Inside Group Users Loop")
				new user_id[50],user_name[50],group_name[255]

				SQL_ReadResult(qryGroupUsers, 0, user_name, 50) 
				SQL_ReadResult(qryGroupUsers, 1, user_id, 50)
				SQL_ReadResult(qryGroupUsers, 2, group_name,255) 
	
				GetGroupFlags(group_name,group_flags)
				
				adminpos = GetAdminPosition(user_id)
				if (GetAdminPosition(user_id) == -1) {
					adminpos = admincount
					admincount++
	
					copy(Admins[adminpos][USERID],50,user_id)
					copy(Admins[adminpos][USERNAME],50,user_name)
					copy(Admins[adminpos][USERFLAGS],255,group_flags)
				}
				else{
					strcat(Admins[adminpos][USERFLAGS],group_flags,255)
				}
				
				adminpos = -1

				SQL_NextRow(qryGroupUsers)
			}
		}
		
		SQL_FreeHandle(qryGroupUsers)
		
	}
	
	//Close the connection	
	//dbi_close(mysql)
	SQL_FreeHandle(mysql)
	
	
	new strUsersFileNew[64],strUsersFile[64],strLine[255]
	format(strUsersFileNew, 63, "%s/users.ini", configDir)
	format(strUsersFile, 63, "%s/users.ini", configDir)
	
	delete_file (strUsersFileNew)
	
	for (i = 0;i<admincount;i++){
		CleanFlags(Admins[i][USERFLAGS])
		
		format(strLine, 255, "%s ^"^" ^"%s^" ^"ce^" ;%s",Admins[i][USERID],Admins[i][USERFLAGS], Admins[i][USERNAME]) 
		write_file(strUsersFileNew,strLine,-1)
	}
	
	write_file(strUsersFileNew,"^"loopback^" ^"^" ^"abcdefghijklmnopqrstu^" ^"de^"", -1)
	
	//new error[250]
	if (file_exists(strUsersFileNew))
		ServerOut("Users file copied")
	
	return PLUGIN_HANDLED
}

public ServerOut(output[500],{Float,Sql,Result,_}:...){
	
	new logMsg[ 500 ] 
	format_args( logMsg, 500 , 0 ) 
	
	new strout[500]
	format(strout,500,"[DB MOD] %s",logMsg)

	server_print(strout)
	log_amx(strout)
}

public GetGroupFlags(group_name[],flags[255]){
	for (new i = 0;i<groupcount;i++){
		if (equali(Groups[i][GROUPNAME],group_name)){
			copy(flags,255,Groups[i][GROUPFLAGS])
			return
		}
	}
	copy(flags,63,"")
	return
}

public GetAdminPosition(steam_id[]){
	for (new i = 0;i<admincount;i++){
		if (equali(Admins[i][USERID],steam_id))
			return i
	}
	return -1
}

public CleanFlags(flags[]){
	new newflags[40]
	if(strfind(flags,"a") != -1)
		strcat(newflags,"a",40)
	
	if(strfind(flags,"b") != -1)
		strcat(newflags,"b",40)
	
	if(strfind(flags,"c") != -1)
		strcat(newflags,"c",40)
	
	if(strfind(flags,"d") != -1)
		strcat(newflags,"d",40)
	
	if(strfind(flags,"e") != -1)
		strcat(newflags,"e",40)
	
	if(strfind(flags,"f") != -1)
		strcat(newflags,"f",40)
	
	if(strfind(flags,"g") != -1)
		strcat(newflags,"g",40)
	
	if(strfind(flags,"h") != -1)
		strcat(newflags,"h",40)
	
	if(strfind(flags,"i") != -1)
		strcat(newflags,"i",40)
	
	if(strfind(flags,"j") != -1)
		strcat(newflags,"j",40)
	
	if(strfind(flags,"k") != -1)
		strcat(newflags,"k",40)
	
	if(strfind(flags,"l") != -1)
		strcat(newflags,"l",40)
	
	if(strfind(flags,"m") != -1)
		strcat(newflags,"m",40)
	
	if(strfind(flags,"n") != -1)
		strcat(newflags,"n",40)
	
	if(strfind(flags,"o") != -1)
		strcat(newflags,"o",40)
	
	if(strfind(flags,"p") != -1)
		strcat(newflags,"p",40)
	
	if(strfind(flags,"q") != -1)
		strcat(newflags,"q",40)
	
	if(strfind(flags,"r") != -1)
		strcat(newflags,"r",40)
	
	if(strfind(flags,"s") != -1)
		strcat(newflags,"s",40)
	
	if(strfind(flags,"t") != -1)
		strcat(newflags,"t",40)
	
	if(strfind(flags,"u") != -1)
		strcat(newflags,"u",40)
	
	copy(flags,40,newflags)
}

public set_steam_id(id,level,cid ){
		
	if (!cmd_access(id, level, cid, 3))
		return PLUGIN_HANDLED


	new fusername[32]
	new fpassword[32]
	
	read_argv(1,fusername,31)
	read_argv(2,fpassword,31)
	
	//Protect against sql injection
	replace( fusername, 31, "'", "''" )
	replace( fpassword, 31, "'", "''" )
	
	//ServerOut("Username : %s - Password : %s",fusername,fpassword)
		
	new query[512]
	new data[1]
	
	format(query, 512, "Select u.user_id, s.steamid from %susers as u \
	                    left join %slinker as s on u.user_id = s.user_id where \
			    u.username = '%s' and \
			    u.user_password = MD5('%s')",
			    s_bbmod_phpbb_prefix,
			    s_bbmod_prefix,
			    fusername,
			    fpassword)
	
	data[0] = id
	
	SQL_ThreadQuery(dbtuple, "find_forum_record", query, data, 1)
	
	return PLUGIN_HANDLED
}

public find_forum_record(fstate, Handle:query, error[], errnum, data[], size)
{
	new id = data[0]
	new steamid[32]
	get_user_authid(id, steamid, 31)

	if (fstate)
	{
		thread_failed(fstate, errnum, error)
	}
	else
	{
		new result = SQL_NumResults(query)
		
		if(result == 0)
		{
			client_print(id,print_chat,"[DB MOD] Your forum record was not found.  Make sure you entered your username")
			client_print(id,print_chat,"and password correctly.  If either of them have a space in it please place")
			client_print(id,print_chat,"quotes ^" ^" around them.")
		}
		else
		{
			new user_id[32]
			new dbsteamid[32]
			
			SQL_ReadResult(query, 0, user_id, 31)
			SQL_ReadResult(query, 1, dbsteamid, 32)
		
			if (!strlen(dbsteamid))
			{
				new query[150], data[1]
				format(query, 149, "Insert into %slinker (user_id,steamid) values (%s,'%s')",s_bbmod_prefix,user_id,steamid)
				data[0] = id
				SQL_ThreadQuery(dbtuple, "insert_steamid", query, data, 1)
			}
			else
			{
				new query[512], data[1]
				format(query, 149, "Update %slinker set steamid = '%s' where user_id = %s",s_bbmod_prefix,steamid,user_id)
				data[0] = id
				SQL_ThreadQuery(dbtuple, "update_steamid", query, data, 1)
			}
		}
	}   
}

public insert_steamid(fstate, Handle:query, error[], errnum, data[], size)
{
	new id = data[0]
	
	if (fstate)
	{
		thread_failed(fstate, errnum, error)
		client_print(id,print_chat ,"[DB MOD] Forum link was not properly created.")
	}
	else
	{
		client_print(id,print_chat,"[DB MOD] Forum link was created.")
	}   
	
}

public update_steamid(fstate, Handle:query, error[], errnum, data[], size)
{
	new id = data[0]
	
	if (fstate)
	{
		thread_failed(fstate, errnum, error)
		client_print(id,print_chat,"[DB MOD] Forum link was not properly updated.")
	}
	else
	{
		client_print(id,print_chat,"[DB MOD] Forum link was updated.")
	}   
	
}

public thread_failed(fstate, errnum, error[])
{
    if (fstate == TQUERY_CONNECT_FAILED)
    {
        ServerOut("DB Connection Failed")
    }
    else if (fstate == TQUERY_QUERY_FAILED)
    {
        ServerOut("DB Query Failed")
    }
    ServerOut("Error: %d :: %s", errnum, error);
}

public bbmod_advert(data[])
{
	new id = data[0]
	new message[255]
	
	
	
	if (!get_pcvar_num(p_advert_show))
		return PLUGIN_HANDLED

	switch(get_pcvar_num(p_advert_format))
	{
		case 1 :
		{
			client_print(id,print_chat,"[BB MOD] To link your steamid to the forums at the console run:")
			client_print(id,print_chat,"amx_setsteamid ^"your username here^" ^"your password here^"")
		}
		case 2 :
		{
			format(message, 254, "[BB MOD] To link your steamid to the forums at the console run:^n\
					      amx_setsteamid ^"your username here^" ^"your password here^"")
					      
			//set_hudmessage ( r, g, b, x, y, effects, fxtime, holdtime, fadeintime, fadeouttime, channel)
			set_hudmessage(255, 0, 0, -1.0, 0.3, 0, 1.0, 5.0, 0.1, 0.2, 4)
			show_hudmessage(id, message)
		}
		default :
		{
			client_print(id,print_chat,"[BB MOD] To link your steamid to the forums at the console run:")
			client_print(id,print_chat,"amx_setsteamid ^"your username here^" ^"your password here^"")
		}
        }

	if (!get_pcvar_num(p_advert_dontannoy))
		set_task(get_pcvar_float(p_advert_frequency) * 60,"bbmod_advert",id,data,1)
		
	return PLUGIN_HANDLED
}

public client_connect(id)
{
	new query[512]
	new data[1]
	new steamid[32]
	get_user_authid(id, steamid, 31)
	
	if (equal(steamid,"BOT"))
		return PLUGIN_HANDLED
	
	format(query, 512, "Select steamid from %slinker as l where \
			    l.steamid = '%s'",
			    s_bbmod_prefix,
			    steamid)
	
	data[0] = id
	
	SQL_ThreadQuery(dbtuple, "check_registration", query, data, 1)
	
	return PLUGIN_HANDLED
}

public check_registration(fstate, Handle:query, error[], errnum, data[], size)
{
	new id = data[0]

	if (fstate)
	{
		thread_failed(fstate, errnum, error)
	}
	else
	{
		new result = SQL_NumResults(query)
		
		if(!result)
		{
			if (get_pcvar_num(p_advert_show))
				if (get_pcvar_float(p_advert_delay) > 0.0)
				{
					set_task(get_pcvar_float(p_advert_delay) * 60,"bbmod_advert",id,data,1)
				}
				else
				{
					set_task(30.0,"bbmod_advert",id,data,1)
				}
		}
	}
}
